#include <math.h>	/* -lm */
#include <stdio.h>
#include <stdlib.h>
#include<string.h>
#include<unistd.h>
#include<pthread.h>	/* -lpthread */

#include "coordinates.h"
#include "run.h"
#include "motor.h"
#include "uss.h"
#include "compass.h"
#include "io_read.h"
#include "controller.h";
#include "mirs.h"
#include "img.h"
#include "chase.h"

#define DIAGONAL 1.41	/*およそsqrt(2)*/



extern Motor* motor_l;
extern Motor* motor_r;

float speed = 15;
float x = 500;	
float x_margin=20;
double angle_ref;
float x_l,x_r;
double dir_margin =2.0;

int scouting(void){				/*追跡時の巡回(哨戒)プログラム*/

	RunStatus* status;
	int stolen = 0;		/*盗まれた宝の数*/
	int last_treasure = 0;		//最後のcheckpoint
	int last_stolen = 0;		//最後に盗まれた宝の番号..比較用
	while(1){
		if(direction != 0){		/*怪盗発見時*/
			last_treasure = 0;
			chase();
		}
/*		else if(last_stolen != stolen_num){	//宝が盗まれたと判明したとき
			tracking(last_treasure);
			last_stolen = stolen_num;
			stolen++;
			last_treasure = 0;
			if( stolen == 6){	//宝が全て盗まれたとき...
				return -1;
			}
		}
*/
		else{		/*巡回異常無しの時*/
			int flont,side;				
			flont = uss[0];/*正面*/
			side = uss[1];/*右側*/
			if(flont >= 50 && side >= 50){
				if(flont >= side){
					angle_ref = ((int)(angle/90)*90);
					status = run_straight_init(motor_l,motor_r);
					while( fabs(x_margin) < fabs(x - run_straight_to(x,speed,angle_ref,status)) ){
						x_l = motor_get_count(motor_l) * MIRS_DISTANCE_TO_PULSE_RATIO;
						x_r = motor_get_count(motor_r) * MIRS_DISTANCE_TO_PULSE_RATIO;
					}	
					run_straight_finish(status); // 停止処理
					motor_set_count(motor_l,motor_get_count(motor_l));
					motor_set_count(motor_r,motor_get_count(motor_r));					
				}else{
					angle_ref = (((int)(angle/90)+1)*90);
					status = run_straight_init(motor_l,motor_r);
					while( fabs(x_margin) < fabs(x - run_straight_to(x,speed,angle_ref,status)) ){
						x_l = motor_get_count(motor_l) * MIRS_DISTANCE_TO_PULSE_RATIO;
						x_r = motor_get_count(motor_r) * MIRS_DISTANCE_TO_PULSE_RATIO;
					}	
				run_straight_finish(status); // 停止処理
				motor_set_count(motor_l,motor_get_count(motor_l));
				motor_set_count(motor_r,motor_get_count(motor_r));					
				}	
			}else if(flont >= 50){
				angle_ref = ((int)(angle/90)*90);
				status = run_straight_init(motor_l,motor_r);
				while( fabs(x_margin) < fabs(x - run_straight_to(x,speed,angle_ref,status)) ){
					x_l = motor_get_count(motor_l) * MIRS_DISTANCE_TO_PULSE_RATIO;
					x_r = motor_get_count(motor_r) * MIRS_DISTANCE_TO_PULSE_RATIO;
				}	
				run_straight_finish(status); // 停止処理
				motor_set_count(motor_l,motor_get_count(motor_l));
				motor_set_count(motor_r,motor_get_count(motor_r));					
			}else if(side >= 50){
				angle_ref = (((int)(angle/90)+1)*90);
				status = run_straight_init(motor_l,motor_r);
				while( fabs(x_margin) < fabs(x - run_straight_to(x,speed,angle_ref,status)) ){
					x_l = motor_get_count(motor_l) * MIRS_DISTANCE_TO_PULSE_RATIO;
					x_r = motor_get_count(motor_r) * MIRS_DISTANCE_TO_PULSE_RATIO;
				}	
				run_straight_finish(status); // 停止処理
				motor_set_count(motor_l,motor_get_count(motor_l));
				motor_set_count(motor_r,motor_get_count(motor_r));					
			}else{
				angle_ref = (((int)(angle/90)+2)*90);
				status = run_straight_init(motor_l,motor_r);
				while( fabs(dir_margin) < fabs(angle_ref - run_rotate_to(angle_ref,speed,status)) ){
					x_l = motor_get_count(motor_l) * MIRS_DISTANCE_TO_PULSE_RATIO;
					x_r = motor_get_count(motor_r) * MIRS_DISTANCE_TO_PULSE_RATIO;
				}
				usleep(60e3);
				run_straight_finish(status);
				motor_set_count(motor_l,motor_get_count(motor_l));
				motor_set_count(motor_r,motor_get_count(motor_r));
			}
		// 停止処理
/*		
			int next_dir = square[x_pos][y_pos][5];	//next_dir:巡回方向[deg]
			if( (ceil((next_dir + 45)/90)%2) == 0){
				next_pos = (square[x_pos][y_pos][6] + x_pos ) * 500.0 + 250.0;
				axes = 1;				//x座標を選択
			}else{
				next_pos = (square[x_pos][y_pos][6] + y_pos ) * 500.0 + 250.0;
				axes = 0;				//y座標を選択
			}			
			run_absolute(axes,next_pos,next_dir);
			if(square[x_pos][y_pos][4] >= 10){
				last_treasure = square[x_pos][y_pos][4]; 
			}
*/
		}
	}
	return 0;
}



int tracking(int last_treasure){
/*	int i,j;
	for(i=0;i<MAX_DAT;i++){
		for(j=0;i<MAX_DAT;j++){
			if( square[i][j][4] == (stolen_num + 10) ){ 
				break;	//宝に近いマスを指定...
			}		//[i][j]:宝のマス目
		}
	}
	int sel_data;	//急行ルートを選ぶ
	if( (last - stolen_num < 0) || (5 <= last - stolen_num) ){
		sel_data = 5;	//左回りのほうが早い
	}else{
		sel_data = 7;	//右回りの方が早い
	}
	//現場近くまで急行する
	do{
		if(direction != 0){
			chase();
			break;
		}else{
			int axes;	//絶対座標の指定軸を設定
			int x_pos = (floor)(current_x / 500.0);
			int y_pos = (floor)(current_y / 500.0);
			int next_dir = square[x_pos][y_pos][sel_data];	//next_dir:巡回方向[deg]
			float next_pos = square[x_pos][y_pos][(sel_data+1)] * 500.0 + 250.0;	//next_pos:目標座標..マスの中心で
			if( (ceil((next_dir + 45)/90)%2) == 0){
				axes = 1;				//x座標を選択
			}else{
				axes = 0;				//y座標を選択
			}
			run_absolute(axes,next_pos,next_dir);
		}
	}while( (x_pos != i) || (y_pos != j) );
	//周囲を確認する...各位置ごと

	switch(stolen_num){
		case 1:
			run_absolute(1,750,0);	//[1,2]
			if(direction != 0){
				chase();
				break;
			}else{
				run_absolute(0,250,270);	//[1,0]
			}
			if(direction != 0){
				chase();
			}else{
				run_absolute(2,750,0);	//[1,0]:その場回転
			}
			break;
		case 2:
			run_absolute(1,1250,0);		//[4,2]
			if(direction != 0){
				chase();
				break;
			}else{
				run_absolute(0,1250,90);	//[4,4]
			}
			if(direction != 0){
				chase();
			}else{
				run_absolute(0,250,270);	//[2,4]
			}
			break;
		case 3:
			run_absolute(2,750,270);	//[4,2]:その場回転
			if(direction != 0){
				chase();
				break;
			}else{
			run_absolute(1,1750,180);		//[3,2]
			}
			if(direction != 0){
				chase();
				break;
			}else{
				run_absolute(0,250,270);	//[3,0]
			}
			if(direction != 0){
				chase();
			}else{
				run_absolute(1,750,180);	//[1,0]
			}
			break;
		case 4:
			run_absolute(1,4250,0);		//[8,2]
			if(direction != 0){
				chase();
				break;
			}else{
				run_absolute(0,750,270);	//[8,1]
			}
			if(direction != 0){
				chase();
			}else{
				run_absolute(1,3250,180);	//[6,1]
			}		
			break;
		case 5:
			run_absolute(1,4250,0);		//[8,4]
			if(direction != 0){
				chase();
				break;
			}else{
				run_absolute(0,1250,270);	//[8,2]
			}
			if(direction != 0){
				chase();
			}else{
				run_absolute(2,4250,180);	//[8,2]:その場回転
			}		
			break;
		case 6:
			run_absolute(2,3750,0);		//[7,5]:その場回転
			if(direction != 0){
				chase();
			}else{
				run_absolute(2,3750,180);	//[7,5]:その場回転
			}		
			break;
		case 7:
			run_absolute(0,4250,90);		//[7,8]
			if(direction != 0){
				chase();
				break;
			}else{
				run_absolute(2,3750,0);	//[7,8]:その場回転
			}
			if(direction != 0){
				chase();
			}else{
				run_absolute(0,3750,270);	//[7,7]
			}		
			break;
		case 8:
			run_absolute(2,3750,90);		//[5,7]:その場回転
			if(direction != 0){
				chase();
			}else{
				run_absolute(2,3750,180);	//[5,7]:その場回転
			}
			break;
		case 9:
			run_absolute(0,4750,90);		//[2,9]
			if(direction != 0){
				chase();
				break;
			}else{
				run_absolute(1,750,180);	//[1,9]
			}
			if(direction != 0){
				chase();
			}else{
				run_absolute(2,4750,270);	//[1,9]:その場回転
			}
			break;
		case 10:
			run_absolute(1,1250,0);		//[2,7]
			if(direction != 0){
				chase();
			}else{
				run_absolute(0,3250,270);	//[2,7]:その場回転
			}
			break;
	}
	if(direction != 0){
		chase();
	}
	return 0;
*/
}


		/*怪盗をロストするまで。赤外線はもう...orz*/
/*		//slant : マス目に対して直角か、斜めか判断する材料
		int slant = ((int)angle) % 90;
		if(){		//中央の赤外線が反応しているとき
			if( (slant >= 30) && (slant <= 60) ){	//斜めに向いているとき
				run_straight(500*DIAGONAL);
			}else{							//マスに直角なとき
				run_straight(500);
			}
			continue;
		}else if(){		//右側の赤外線が反応しているとき
			run_rotate(angle + 45);
			if( (slant >= 30) && (slant <= 60) ){	//マスに直角なとき
				run_straight(500);	
			}else{							//斜めに向いているとき
				run_straight(500*DIAGONAL);
			}
			continue;
		}else if(){		//左側の赤外線が反応しているとき
			run_rotate(angle - 45);
			if( (slant >= 30) && (slant <= 60) ){	//マスに直角なとき
				run_straight(500);
			}else{							//斜めに向いているとき
				run_straight(500*DIAGONAL);
			}
			continue;
		}else{			//赤外線では判断し難いとき
		}
*/
int chase(void){
	RunStatus* status;
	while(1){
		float reference_dir;
		float next_pos = 0.0;		/*next_pos:目標座標..必要な場合は代入すること*/
		int axes = 2;	//絶対座標の指定軸を設定、直進する場合は代入すること
		int x_pos = (floor)(current_x / 500.0);
		int y_pos = (floor)(current_y / 500.0);

	//現在の画像処理での判断
		switch(direction){	//direction : 1 = 左側 / 2 = 中央左側 / 3 = 中央右側 / 4 = 右側
			case 1:
/*
				reference_dir = (floor((angle + 22.5)/45.0)-1)*45;	//現在angle、45度±22.5[deg]から-45[deg]
				run_absolute(axes,next_pos,reference_dir);	//その場回転のみ;第2引数は何でも...
*/
				break;
			case 2:
			case 3:
/*
				reference_dir = floor((angle + 22.5)/45.0)*45;	//現在angle、45度±22.5[deg]
				if( (ceil((reference_dir + 45)/90)%2) == 0){
					axes = 1;				//x座標を選択
					if(reference_dir <= 180.0){
						next_pos = (x_pos + 1) * 500.0 + 250.0;
					}else{
						next_pos = (x_pos - 1) * 500.0 + 250.0;
					}
				}else{
					axes = 0;				//y座標を選択
					if(reference_dir <= 90.0 || 270.0 <= reference_dir){
						next_pos = (y_pos + 1) * 500.0 + 250.0;
					}else{
						next_pos = (y_pos - 1) * 500.0 + 250.0;
					}
				}
				run_absolute(axes,next_pos,reference_dir);
*/
				break;
			case 4:
/*
				reference_dir = (floor((angle + 22.5)/45.0)+1)*45;	//現在angle、45度±22.5[deg]から+45[deg]
				run_absolute(2,next_pos,reference_dir);	//その場回転のみ;第2引数は何でも...
				break;
			case 0:
				sleep(1);			//画像処理の時間を作る..
*/
				break;
		}
		if(direction == 0){
			coordinates_correct();
			return 0;			/*座標修正後警備へ戻る*/
		}
	}
}

/*
	//盗難情報を常にチェックする(スレッド起動)
void stolen_thread(void){
	int before_sum = 0;	//宝の番号の和を保持し、差で盗難情報を検出する
	int sum;
	char *tp;	//文字列代入用
	FILE *fp;
	if((fp = fopen("stolen.txt","r")) == NULL){
		printf("stolen_info load failed.\n");	//ファイルが開けない
		exit(1);
	}
	while(1){
		stolen_check();		
		char buf[127];
		if((fgets(buf,127,fp)) != NULL){		//1行データを読む
			tp = strtok(buf,",");
			sum = 0;
			while(tp != NULL){	//盗難番号がある間
				sum = sum + atoi(tp);	//盗難された宝の番号の和
				tp = strtok(NULL,",");
			}
		}
		if(before_sum < sum){
			stolen_num = sum - before_sum;
			sleep(3);		//盗難情報の更新間隔は早くなくても..
		}
	}
	fclose(fp);	
}

	//サーバーに接続して盗難情報が書かれたファイルを持ってくる
void stolen_check(void){
	char command[100];
	sprintf(command, "python sshstolen.py");	
	system(command);
}
*/

