/*
 * controller_summer.c
 *
 *  Created on: 2013/08/02
 *      Author: d10130
 *
 */
#include <stdlib.h>
#include <stdint.h>
#include <stdio.h>
#include <math.h>
#include <unistd.h>
#include "mirs.h"
#include "motor.h"
#include "run.h"
#include "uss.h"
#include "ts_ws.h"

// 左右のモーター
Motor* motor_l;
Motor* motor_r;

// サブルーチン
static void device_open(void);
static void device_close(void);
void search_line(void);

int controller(){
	RunStatus* status;
	float speed,angle_speed;
	float x,x_margin;
	float angle,angle_margin;

	// デバイスオープン
	device_open();
	printf("starting...\n");

while(1);

	speed = 2;
	angle_speed = 0.5;
	x_margin = 3;
	angle_margin = 1;


	printf("白線まで前進\n");
	status = run_straight_init(motor_l,motor_r);
	while( !ts_ws_get(WS_PORT_L) && !ts_ws_get(WS_PORT_R) ){
		run_straight(speed,status);
	}
	run_straight_finish(status);
	
	printf("白線を跨ぐ \n");
	status = run_straight_init(motor_l,motor_r);
	while( ts_ws_get(WS_PORT_L) || ts_ws_get(WS_PORT_R) ){
		run_straight(speed,status);
	}
	run_straight_finish(status);

	printf("向きを白線に揃える\n");
	search_line();

	printf("1ブロック前進");
	x = 700.0;
	status = run_straight_init(motor_l,motor_r);
	while( x_margin < fabs(x - run_straight_to(x,speed,status) )){
		if( ts_ws_get(TS_PORT_F) ) break;
	}
	run_straight_finish(status);
	x = -50.0;
	status = run_straight_init(motor_l,motor_r);
	while( x_margin < fabs(x - run_straight_to(x,speed,status) )){
		if( ts_ws_get(TS_PORT_F) ) break;
	}
	run_straight_finish(status);


	printf("90度旋回");
	angle = 90.0;
	status = run_rotate_init(motor_l,motor_r);
	while( angle_margin < fabs(angle - run_rotate_to(angle,angle_speed,status) ));
	run_rotate_finish(status);
	puts("clear");getchar();


	printf("白線まで前進\n");
	status = run_straight_init(motor_l,motor_r);
	motor_brake(motor_l); motor_brake(motor_r);
	while( !ts_ws_get(WS_PORT_L) && !ts_ws_get(WS_PORT_R) ){
		run_straight(speed,status);
	}
	run_straight_finish(status);

	printf("白線を跨ぐ \n");
	status = run_straight_init(motor_l,motor_r);
	while( ts_ws_get(WS_PORT_L) || ts_ws_get(WS_PORT_R) ){
		run_straight(speed,status);
	}
	run_straight_finish(status);

	printf("向きを白線に揃える\n");
	search_line();

	printf("1ブロック前進");
	x = 400.0;
	status = run_straight_init(motor_l,motor_r);
	while( x_margin < fabs(x - run_straight_to(x,speed,status) )){
		if( ts_ws_get(TS_PORT_F) ) break;
	}
	run_straight_finish(status);

	printf("90度旋回");
	angle = 89.0;
	status = run_rotate_init(motor_l,motor_r);
	while( angle_margin < fabs(angle - run_rotate_to(angle,angle_speed,status) ));
	run_rotate_finish(status);


	printf("3ブロック前進");
	x = 1500.0;
	status = run_straight_init(motor_l,motor_r);
	while( x_margin < fabs(x - run_straight_to(x,speed,status) )){
		if( ts_ws_get(TS_PORT_F) ) break;
	}
	run_straight_finish(status);

	printf("90度旋回");
	angle = -90.0;
	status = run_rotate_init(motor_l,motor_r);
	while( angle_margin < fabs(angle - run_rotate_to(angle,angle_speed,status) ));
	run_rotate_finish(status);


	device_close();
	return 0;
}

void search_line(void){
	RunStatus* status;
	float angle1 = 0,angle2 = 0, angle_ave;
	float speed = 0.5;
	
	status = run_rotate_init(motor_l,motor_r);

	printf("左のWSが反応するまで左旋回 ");
	do{ angle1 = run_rotate(speed,status);  }while( !ts_ws_get(WS_PORT_L) );
	puts("clear");

	printf("左のWSが反応しなくなるまで右旋回 ");
	do{ run_rotate(-speed,status);  }while( ts_ws_get(WS_PORT_L) );
	puts("clear");
	
	printf("右のWSが反応するまで右旋回 ");
	do{ angle2 = run_rotate(-speed,status);  }while( !ts_ws_get(WS_PORT_R) );
	puts("clear");
	
	printf("平均の角度を向く ");
	angle_ave = (angle1 + angle2)/2.0;
	while( 1.0 < fabs(angle_ave - run_rotate_to(angle_ave,speed,status)) );
	puts("clear");
	
	run_rotate_finish(status);
}

static void device_open(void){
	int err;

	printf("opening device...\n");
	// タッチセンサー,白線センサー
	err = ts_ws_open(TS_WS_DEV_FILE);
	if(err){
		fprintf(stderr,"[ERROR] cannot open : %s : ts,ws\n",TS_WS_DEV_FILE);
		exit(-1);
	}
	// USS
	err = uss_open(USS_DEV_FILE,USS_ADDR_MAX);
	if(err){
		fprintf(stderr,"[ERROR] cannot open : %s : USS\n",USS_DEV_FILE);
		exit(-1);
	}
	// 左モーター
	err = motor_open(MOTOR_L_DEV_FILE,&motor_l);
	if(err){
		fprintf(stderr,"[ERROR] cannot open : %s : left motor\n",MOTOR_L_DEV_FILE);
		exit(-1);
	}
	// 右モーター
	err = motor_open(MOTOR_R_DEV_FILE,&motor_r);
	if(err){
		fprintf(stderr,"[ERROR] cannot open : %s : right motor\n",MOTOR_R_DEV_FILE);
		exit(-1);
	}
}

static void device_close(void){
	printf("closing device...\n");
	ts_ws_close();
	uss_close();
	motor_close(motor_l);
	motor_close(motor_r);
}
