#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>
#include <math.h>
#include "mirs.h"
#include "controller.h"
#include "uss.h"
#include "motor.h"
#include "io_read.h"
#include "compass.h"
#include "run.h"
#include "img.h"
#include "coordinates.h"
#include "chase.h"


int fd4;
Motor* motor_l;
Motor* motor_r;

int main(){
	//使用するUSSの数を設定
	int uss_max = 2;
	// タスクID変数の宣言
//	pthread_t uss_task;
	//タスク属性変数の宣言
//	pthread_attr_t attr_uss;
	// スケジュールパラメータ
	struct sched_param sched_param_uss;
	//USS スレッド
	pthread_attr_init (&attr_uss);
	sched_param_uss.sched_priority = 20;
	pthread_attr_setschedpolicy(&attr_uss, SCHED_RR);
	pthread_attr_setschedparam(&attr_uss, &sched_param_uss);
	printf("USS thread create..\n");
	pthread_create(&uss_task, &attr_uss, (void *)uss_read_thread, (void *)uss_max);


	// タスクID変数の宣言
	pthread_t compass_task;
	//タスク属性変数の宣言
	pthread_attr_t attr_compass;
	// スケジュールパラメータ
	struct sched_param sched_param_compass;
	//電子コンパススレッド
	pthread_attr_init (&attr_compass);
	sched_param_compass.sched_priority = 20;
	pthread_attr_setschedpolicy(&attr_compass, SCHED_RR);
	pthread_attr_setschedparam(&attr_compass, &sched_param_compass);
	printf("Compass thread create..\n");
	pthread_create(&compass_task, &attr_compass, (void *)compass_thread, NULL);




	// タスクID変数の宣言
	pthread_t img_task;
	//タスク属性変数の宣言
	pthread_attr_t attr_img;
	// スケジュールパラメータ
	struct sched_param sched_param_img;
	//USS スレッド
	pthread_attr_init (&attr_img);
	sched_param_img.sched_priority = 20;
	pthread_attr_setschedpolicy(&attr_img, SCHED_RR);
	pthread_attr_setschedparam(&attr_img, &sched_param_img);
	printf("Ball find thread create..\n");
	pthread_create(&img_task, &attr_img, (void *)ball_find_thread, NULL);


	//RunStatus* status;

	// デバイスが開けるか検査
	printf("opening device ...\n");
	if(motor_open(MOTOR_L_DEV_FILE,&motor_l)){
		fprintf(stderr,"[ERROR] cannot open : %s : left motor\n",MOTOR_L_DEV_FILE);
		exit(-1);
	}
	printf("left motor : success\n");
	if(motor_open(MOTOR_R_DEV_FILE,&motor_r)){
		fprintf(stderr,"[ERROR] cannot open : %s : right motor\n",MOTOR_R_DEV_FILE);
		exit(-1);
	}
	printf("right motor : success\n");
	
	//io_read用
	fd4 = open("/dev/irs_ts_ws", O_RDONLY);

	

	while(getchar()!='\n');
	printf("waiting");
	while(angle==0.0){
		sleep(3);	
	}
	printf("OK!!");
	while(getchar()!='\n');



	// タスクID変数の宣言
	pthread_t coordinates_task;
	//タスク属性変数の宣言
	pthread_attr_t attr_coordinates;
	// スケジュールパラメータ
	struct sched_param sched_param_coordinates;
	//座標推測スレッド
	pthread_attr_init (&attr_coordinates);
	sched_param_coordinates.sched_priority = 20;
	pthread_attr_setschedpolicy(&attr_coordinates, SCHED_RR);
	pthread_attr_setschedparam(&attr_coordinates, &sched_param_coordinates);
	printf("Coordinates thread create..\n");
	pthread_create(&coordinates_task, &attr_coordinates, (void *)coordinates_thread, NULL);




	// 起動
	junkai();
	
	//shoukai
//	scouting();

	//スレッドの結合
	pthread_join(uss_task,NULL);
	pthread_join(compass_task,NULL);
	pthread_join(coordinates_task,NULL);
	pthread_join(img_task,NULL);
	return 0;
}


