#ifndef __MIRS_H__
#define __MIRS_H__


/******** コースデータ ********/

// 1区画の幅[mm]
#define BLOCK_SIZE 500
// ロータリーの半径[mm]
#define ROTARY_RADIUS  ( (1200.0 + 200.0)/2.0 ) // 柱の半径200[mm],壁の半径1200[mm]



/******** 機体サイズ ********/

// 中心からタイヤまでの距離[mm]
#define MIRS_BODY_RADIUS 153
// タイヤの半径[mm]
#define MIRS_WHEEL_RADIUS 57
// モーター1回転あたりのエンコーダーの回転数[cyc/cyc]
#define MIRS_MOTOR_TO_ENCODER_RATIO 1.43
// ロータリーエンコーダ1回転あたりのパルス発生回数[pulse/cyc]
#define MIRS_ROUND_TO_PULSE_RATIO 360
// パルス1回分の走行距離[mm/pulse]
#define MIRS_DISTANCE_TO_PULSE_RATIO \
	(2*3.141593*MIRS_WHEEL_RADIUS * MIRS_MOTOR_TO_ENCODER_RATIO/MIRS_ROUND_TO_PULSE_RATIO)



/******** センサー情報 ********/

// USSボードの総数
#define USS_ADDR_MAX 2

// 左向き前側のUSS
#define USS_ADDR_FL 1
// 左向き後側のUSS
#define USS_ADDR_FR 3
// 右向きのUSS
#define USS_ADDR_L 2
// 正面のUSS
#define USS_ADDR_R 4

// 左の白線センサ
#define WS_PORT_L 0
// 右の白線センサ
#define WS_PORT_R 1
// 正面のタッチセンサ
#define TS_PORT_F 8
// 左のタッチセンサ
#define TS_PORT_L 9
// 右のタッチセンサ
#define TS_PORT_R 10



/******** デバイスファイル ********/
// ここに書くべきか迷う

// USSのデバイスファイル
#define USS_DEV_FILE "/dev/ttyS0"
// 左モータのデバイスファイル
#define MOTOR_L_DEV_FILE "/dev/mirS1"
// 右モータのデバイスファイル
#define MOTOR_R_DEV_FILE "/dev/mirS0"
// TS,WSのデバイスファイル
#define TS_WS_DEV_FILE "/dev/irs_ts_ws"

extern int fd4;


#endif
