#include<math.h>	/* -lm	 */
#include<pthread.h>	/* -lpthread */
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<unistd.h>

#include"uss.h"
#include"io_read.h"
#include"run.h"
#include"compass.h"
#include"controller.h"
#include"motor.h"
#include"mirs.h"
	//̃\[Xt@C̒萔
#include"coordinates.h"

extern Motor* motor_l;
extern Motor* motor_r;

pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;

volatile float encoder_dis;
float current_x,current_y;
char square[MAX_DAT][MAX_DAT][MAX_ELE];


void coordinates_guess(void){
	double arg;
	float before_dis = 0.0;	/*before_dis:Õ[^[GR[_lێ*/
	float now_dis;			/*now_dis:݂̃[^[GR[_lێ*/
	
	current_x = INIT_X;
	current_y = INIT_Y;
	while(1){
		before_dis = now_dis;
		now_dis = encoder_dis;

		/*ړɂ茻݂̍WvZ*/
		if(now_dis != before_dis && now_dis != 0.0){
			arg = angle * PI / 180.0;		/* angle[deg](݂̌) -> arg[rad] */
			pthread_mutex_lock(&mutex);
			current_x = current_x + (now_dis - before_dis) * sin(arg);
			current_y = current_y + (now_dis - before_dis) * cos(arg);
			pthread_mutex_unlock(&mutex);

			printf("current_x = %f\t",current_x);
			printf("current_y = %f\n",current_y);
		}
	}

}


int coordinates_correct(void){

	int correct_dir;			/*correct_dir:␳Őʂ̎wB*/	
	int wall[4];				/*wall[4]:␳Ɏgpłǂ̏B"0":sA"1":*/

		/*ǂ̌o:2}Xׂ܂łɁu\ȁvǂ邩*/
	int i;
	for( i = 0;i < 4;i++){
		if(distance(current_x,current_y,i) <= 2 && distance(current_x,current_y,i) != -1){	
			wall[i] = 1;
		}else{
			wall[i] = 0;
		}
	}						

		/*gʂ̔(X^[g猩)*/
	if(wall[0] == 1 && wall[1] == 1){			/*:ʁAE*/
		correct_dir = 0;
	}else if(wall[1] == 1 && wall[2] == 1){		/*:EAw*/
		correct_dir = 1;
	}else if(wall[2] == 1 && wall[3] == 1){		/*:wA*/
		correct_dir = 2;
	}else if(wall[3] == 1 && wall[0] == 1){		/*:A*/
		correct_dir = 3;
	}else{
		return -1;					/*␳s*/
	}
	
		/*␳px܂ŉ]*/
	float speed = SPD;
	float x_l,x_r;
	float dir_margin = DIR_MARGIN;
	RunStatus* status;
	status = run_straight_init(motor_l,motor_r);	/*ݒ*/
	for(i = 0;i <= 1;i++){		/*2ɕĕ␳Bs߂}*/
		while( fabs(dir_margin) < fabs(correct_dir*90.0 - run_rotate_to(correct_dir*90.0,speed,status)) ){
			x_l = motor_get_count(motor_l) * MIRS_DISTANCE_TO_PULSE_RATIO;
			x_r = motor_get_count(motor_r) * MIRS_DISTANCE_TO_PULSE_RATIO;
		}
		usleep(60e3);
	}
	run_straight_finish(status);	/*]Iw*/
	motor_set_count(motor_l,motor_get_count(motor_l));
	motor_set_count(motor_r,motor_get_count(motor_r));


		/*݂̍WvZċ߂*/
	switch(correct_dir){
		case 0:
			pthread_mutex_lock(&mutex);
			current_y = ( ceil(current_y / 500.0) + distance(current_x,current_y,0)) * 500.0 + USS_F - uss[0]*10.0;/**/
		 	current_x = ( ceil(current_x / 500.0) + distance(current_x,current_y,1)) * 500.0 + USS_S - uss[1]*10.0;/*E*/
		 	pthread_mutex_unlock(&mutex);
		 	break;
		case 1:
			pthread_mutex_lock(&mutex);
			current_x = ( ceil(current_x / 500.0) + distance(current_x,current_y,1)) * 500.0 + USS_F - uss[0]*10.0;/**/
		 	current_y = (floor(current_y / 500.0) - distance(current_x,current_y,2)) * 500.0 - USS_S + uss[1]*10.0;/*E*/
		 	pthread_mutex_unlock(&mutex);
		 	break; 
		case 2:
		 	pthread_mutex_lock(&mutex);
			current_y = (floor(current_y / 500.0) - distance(current_x,current_y,2)) * 500.0 - USS_F + uss[0]*10.0;/**/
		 	current_x = (floor(current_x / 500.0) - distance(current_x,current_y,3)) * 500.0 - USS_S + uss[1]*10.0;/*E*/ 
		 	pthread_mutex_unlock(&mutex);
		 	break; 
		case 3:
		 	pthread_mutex_lock(&mutex);
			current_x = (floor(current_x / 500.0) - distance(current_x,current_y,3)) * 500.0 - USS_F + uss[0]*10.0;/**/
		 	current_y = ( ceil(current_y / 500.0) + distance(current_x,current_y,0)) * 500.0 + USS_S - uss[1]*10.0;/*E*/
		 	pthread_mutex_unlock(&mutex);
			break;
	}
	return 0;
}


	//TS_centerON̂Ƃɂ̊֐ĂсAWCs(ǐՎȊO)
void coordinates_touch_center(float speed,float dir){		
	float ts_margin = TS_MARGIN;
	float back = BACK;
	float x_l,x_r;
	int dir_now;	//4\ϐ.04͓
	//ǂ̍Wo
	dir_now = (int)( (angle + 45.0) / 90.0);	/*e}45[deg]*/
	//f[^łڂ̑OɕǂƂ̂ݍWC:1̂
	if( distance(current_x,current_y,dir_now) == 0 ){
		switch(dir_now){
			case 1:
			 	pthread_mutex_lock(&mutex);
				current_x = ceil(current_x / 500.0)* 500.0 - TS_DIS;
			 	pthread_mutex_unlock(&mutex);				
				break;
			case 2:
			 	pthread_mutex_lock(&mutex);
				current_y = floor(current_x / 500.0)* 500.0 + TS_DIS;
			 	pthread_mutex_unlock(&mutex);				
				break;
			case 3:
			 	pthread_mutex_lock(&mutex);
				current_x = floor(current_x / 500.0)* 500.0 + TS_DIS;
			 	pthread_mutex_unlock(&mutex);				
				break;
			case 4:
			case 0:
			 	pthread_mutex_lock(&mutex);
				current_y = ceil(current_x / 500.0)* 500.0 - TS_DIS;
			 	pthread_mutex_unlock(&mutex);				
				break;
		}		
	}
	//
	RunStatus* status;
	status = run_straight_init(motor_l,motor_r);
	while( fabs(ts_margin) < fabs( back - run_straight_to(back,-1*speed,dir,status) ) ){
		x_l = motor_get_count(motor_l) * MIRS_DISTANCE_TO_PULSE_RATIO;
		x_r = motor_get_count(motor_r) * MIRS_DISTANCE_TO_PULSE_RATIO;
		encoder_dis = (x_l + x_r) / 2.0;
	}
	run_straight_finish(status);	/*iIw*/
	motor_set_count(motor_l,motor_get_count(motor_l));
	motor_set_count(motor_r,motor_get_count(motor_r));
	encoder_dis = 0.0;
}

void coordinates_touch_side(float speed,float dir){
	float ts_margin = TS_MARGIN;
	float back = BACK;
	float x_l,x_r;
	float dir_margin = DIR_MARGIN;
	RunStatus* status;
	//back̋ނ
	status = run_straight_init(motor_l,motor_r);
	while( fabs(ts_margin) < fabs( back - run_straight_to(back,-1*speed,dir,status) ) ){
		x_l = motor_get_count(motor_l) * MIRS_DISTANCE_TO_PULSE_RATIO;
		x_r = motor_get_count(motor_r) * MIRS_DISTANCE_TO_PULSE_RATIO;
		encoder_dis = (x_l + x_r) / 2.0;
	}
	run_straight_finish(status);	/*iIw*/
	motor_set_count(motor_l,motor_get_count(motor_l));
	motor_set_count(motor_r,motor_get_count(motor_r));
	encoder_dis = 0.0;
	//px̍ĕ␳
	status = run_straight_init(motor_l,motor_r);	/*ݒ*/
	while( fabs(dir_margin) < fabs(dir - run_rotate_to(dir,speed,status)) ){
		x_l = motor_get_count(motor_l) * MIRS_DISTANCE_TO_PULSE_RATIO;
		x_r = motor_get_count(motor_r) * MIRS_DISTANCE_TO_PULSE_RATIO;
	}
	usleep(60e3);
	run_straight_finish(status);	/*]Iw*/
	motor_set_count(motor_l,motor_get_count(motor_l));
	motor_set_count(motor_r,motor_get_count(motor_r));
}



int mapping(void){
	char buf[MAX_BUF];
	char *tp;	/*p*/
	FILE *fp;
	int i,j,data;
		/*t@CI[v`FbN*/
	if((fp = fopen("course.csv","r")) == NULL){
		printf("File not open.\n");
		exit(1);
	}
		/*SẴ}X̃f[^܂*/	
	while((fgets(buf,MAX_BUF,fp)) != NULL){
			/*1ڂ̃f[^BW(i)*/
		tp = strtok(buf,",");
		i = atoi(tp);			
			/*2ڂ̃f[^BW(j)*/
		tp = strtok(NULL,",");
		j = atoi(tp);		
			/*3ڈȍ~̃f[^Af[^؂܂*/
		tp = strtok(NULL,",");
		for(data = 0;tp != NULL;data++){
			square[i][j][data] = atoi(tp);
			tp = strtok(NULL,",");
		}
	}
	fclose(fp);
	return 0;
}


int distance(float x,float y,int dir){
	int x_count,y_count;		/*x_count,y_count:݂̈ʒu}XڊZʒu*/
	int n = 0;			/*͈ʒuǂ܂ł̃}X*/
	x_count = (int)(x / 500.0);	/*500.0:}Xڂ̑傫[mm]*/
	y_count = (int)(y / 500.0);	
	while(square[x_count][y_count][dir] == 0){	/*"0":ǂȂ*/
		n++;
		switch(dir){
			case 0:			/*"0":X^[gƓ*/
				y_count++;	/*"0"ɂ}X𒲂ׂ*/
				break;
			case 1:			/*"1":X^[gE*/
				x_count++;	/*"1"ɂ}X𒲂ׂ*/
				break;
			case 2:			/*"2":X^[g̔*/
				y_count--;	/*"2"ɂ}X𒲂ׂ*/
				break;
			case 3:			/*"3":X^[g*/
				x_count--;	/*"3"ɂ}X𒲂ׂ*/
				break;
		}
	}
	if(square[x_count][y_count][dir] >= 2){	/*"2":s\ȕ*/
		return -1;			/*s\*/
	}else{
		return n;			/*ǂ܂ł̋*/
	}
}
