	//自己位置推定用の関数等

#define PI 3.141592
#define USS_F 35.0		/*正面超音波から機体中心(線)までの幅*/
#define USS_S 95.0		/*側面超音波から機体中心(線)までの幅*/
#define INIT_X 2250.0	/*INIT_X:MIRSスタート位置(x座標)*/
#define INIT_Y 250.0	/*INIT_Y:MIRSスタート位置(y座標)*/
#define MAX_ELE 7		/*各マスごとの情報数*/
#define MAX_DAT 10		/*競技場のマス連続数(縦,横)*/
#define MAX_BUF 64		/*各マスデータの最大サイズ*/
#define TS_MARGIN 3.0	/*TS反応時に後退する距離の許容誤差[mm]*/
#define BACK -50.0		/*TS反応時に後退する距離[mm]*/
#define TS_DIS 135.0	/*正面TSから機体中心までの距離[mm]*/

	
	//ロータリーエンコーダの現在の値を入れる変数。
	//直進時のループ及び直進終了後に値が更新される
extern volatile float encoder_dis;

	//現在の座標(x:横方向,y:縦方向)
extern float current_x,current_y;	

	//コース情報を保持する配列。
	//[i]行[j]列の要素[data]番
extern char square[MAX_DAT][MAX_DAT][MAX_ELE];

	//座標更新時のmutex
//extern pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;

	//座標を推測するスレッド
extern void coordinates_thread(void);


	//自己位置を更新し続ける関数。無限ループ。(スレッドで呼び出すよう)
extern void coordinates_guess(void);

	//2つの超音波を使用して現在の座標を修正する。成功時:0、失敗時:-1 を返す。
	//現在の座標はグローバル関数だから読めるhazu..
extern int coordinates_correct(void);

	//中央のタッチセンサに反応があり、補正する場合に呼び出す。
	//引数: speed:モータースピード、dir:補正後の角度
extern void coordinates_touch_center(float speed,float dir);

	//左右のタッチセンサに反応がある場合に呼び出す。
	//引数: speed:モータースピード、dir:補正後の角度
extern void coordinates_touch_side(float speed,float dir);

	//csvファイルから値を配列に代入する。機体が動く前に呼び出す。
extern int mapping(void);

	//指定座標(x,y)[mm]のマスからdirの方向に何マス壁までの距離があるか調べる。
	//成功時:マス数(0以上)、壁が丸柱や宝:-1 を返す。
extern int distance(float x,float y,int dir);


		/*座標原点:競技場角、現在位置:機体の中心*/

