#include<stdio.h>
#include<math.h>
#include<pthread.h>
#include"motor.h"
#include"run.h"
#include"io_read.h"
#include"uss.h"
#include"compass.h"
#include"coordinates.h"
#include"mirs.h"


extern Motor* motor_l;
extern Motor* motor_r;



void run_absolute(int sel,float reference_coor,float dir){
	//ロータリーエンコーダの値保持
	RunStatus* status;
	float x_l=0.0;
	float x_r=0.0;
	float speed = SPD;
	float dis_margin = DIS_MARGIN;
	float dir_margin = DIR_MARGIN;
	
	//現在の方向が指定方向と違う場合(大体指定の方向(dir[deg])へ向くまで)...
	if( 5.0 <= fabs(dir - angle) && fabs(dir - angle) <= 355.0){	
		status = run_straight_init(motor_l,motor_r);	/*初期設定*/
		int i;
		for(i = 0;i <= 1;i++){		/*2回に分けて補正。行き過ぎを抑える*/
			while( fabs(dir_margin) < fabs(dir - run_rotate_to(dir,speed,status)) ){
				x_l = motor_get_count(motor_l) * MIRS_DISTANCE_TO_PULSE_RATIO;
				x_r = motor_get_count(motor_r) * MIRS_DISTANCE_TO_PULSE_RATIO;
			}
			usleep(60e3);
		}
		run_straight_finish(status);	/*回転終了指定*/
		motor_set_count(motor_l,motor_get_count(motor_l));
		motor_set_count(motor_r,motor_get_count(motor_r));
	}

	//前進の途中で別の値で更新すると、グローバル変数は変化して大変なことになりそう...	
	//そのため、途中でデータをリフレッシュさせ、2重whileループで対応する。
	
	//大体指定の距離(reference_coor[mm])前進するまで直進走行。
	if(sel == 0){	//x座標
		//現在の座標の値を入れる変数。
		float x_pos = current_x;
		while( fabs(x_pos - reference_coor) >= fabs(dis_margin) ){	
		
			status = run_straight_init(motor_l,motor_r);
			while( fabs(x_pos - reference_coor) >= fabs(dis_margin) ){
				run_straight_to(reference_coor,speed,dir,status);
				x_l = motor_get_count(motor_l) * MIRS_DISTANCE_TO_PULSE_RATIO;
				x_r = motor_get_count(motor_r) * MIRS_DISTANCE_TO_PULSE_RATIO;
				encoder_dis = (x_l + x_r) / 2.0;
				x_pos = current_x;	
				io_read();
				if(io_data[8]=='1'||io_data[9]=='1'||io_data[10]=='1'){		//TS判断
					break;
				}			
			}
			run_straight_finish(status);	/*直進終了指定*/
			motor_set_count(motor_l,motor_get_count(motor_l));
			motor_set_count(motor_r,motor_get_count(motor_r));
			encoder_dis = (x_l + x_r) / 2.0;

			if(io_data[8]=='1'||io_data[10]=='1'){	//右or左
				coordinates_touch_side(speed,dir);
			}else if(io_data[9]=='1'){			//正面
				coordinates_touch_center(speed,dir);
				break;
			}else{	//前進終了
				break;			
			}
		}
		
	}else if(sel == 1){		//y座標
		//現在の座標の値を入れる変数。
		float y_pos = current_y;
		while( fabs(y_pos - reference_coor) >= fabs(dis_margin) ){		

			status = run_straight_init(motor_l,motor_r);
			while( fabs(y_pos - reference_coor) >= fabs(dis_margin) ){
				run_straight_to(reference_coor,speed,dir,status);
				x_l = motor_get_count(motor_l) * MIRS_DISTANCE_TO_PULSE_RATIO;
				x_r = motor_get_count(motor_r) * MIRS_DISTANCE_TO_PULSE_RATIO;
				encoder_dis = (x_l + x_r) / 2.0;
				y_pos = current_y;
				io_read();
				if(io_data[8]=='1'||io_data[9]=='1'||io_data[10]=='1'){		//TS判断
					break;
				}
			}
			run_straight_finish(status);	/*直進終了指定*/
			motor_set_count(motor_l,motor_get_count(motor_l));
			motor_set_count(motor_r,motor_get_count(motor_r));
			encoder_dis = (x_l + x_r) / 2.0;

			if(io_data[8]=='1'||io_data[10]=='1'){	//右or左
				printf("ts left or right\n\n\n");
				coordinates_touch_side(speed,dir);
			}else if(io_data[9]=='1'){			//正面
				printf("ts center\n\n\n");
				coordinates_touch_center(speed,dir);
				break;
			}else{	//前進終了
				break;			
			}
		}
	}
	
}


