/*
 * test_motor.c
 *
 *  Created on: 2013/08/07
 *      Author: d10130
 */


#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>
#include "mirs.h"
#include "motor.h"

int main(void){
	Motor* motor_l;
	Motor* motor_r;

	// デバイスが開けるか検査
	printf("opening device ...\n");
	if(motor_open(MOTOR_L_DEV_FILE,&motor_l)){
		fprintf(stderr,"[ERROR] cannot open : %s : left motor\n",MOTOR_L_DEV_FILE);
		exit(-1);
	}
	printf("left motor : success\n");
	if(motor_open(MOTOR_R_DEV_FILE,&motor_r)){
		fprintf(stderr,"[ERROR] cannot open : %s : right motor\n",MOTOR_R_DEV_FILE);
		exit(-1);
	}
	printf("right motor : success\n");

	getchar();
	while(1){
		int dir;
		float speed;
		float x_l,x_r,v_l,v_r;

		for(dir=1;;dir=-dir){
			for(speed=0.0;speed<=5.0;speed+=0.01){
				printf("v_ref=%6.2f[mm/s]",dir*speed);
				motor_set_speed(motor_l,dir*speed / MIRS_DISTANCE_TO_PULSE_RATIO);
				motor_set_speed(motor_r,dir*speed / MIRS_DISTANCE_TO_PULSE_RATIO);
				
				v_l = motor_get_speed(motor_l) * MIRS_DISTANCE_TO_PULSE_RATIO;
				v_r = motor_get_speed(motor_r) * MIRS_DISTANCE_TO_PULSE_RATIO;
				x_l = motor_get_count(motor_l) * MIRS_DISTANCE_TO_PULSE_RATIO;
				x_r = motor_get_count(motor_r) * MIRS_DISTANCE_TO_PULSE_RATIO;
				printf("  v_l=%6.2f[mm/s]  v_r=%6.2f[mm/s]",v_l,v_r);
				printf("  x_l=%8.2f[mm]  x_r=%8.2f[mm]",x_l,x_r);
				printf("\n");

				usleep(50*1000);
			}
			motor_brake(motor_l);
			motor_brake(motor_r);
			getchar();
		}
	}

	// 停止処理
	motor_brake(motor_l);
	motor_brake(motor_r);

	// モータとの通信を終了
	printf("\n");
	printf("closing device ...\n");
	motor_close(motor_l);
	motor_close(motor_r);
}
