/*
正体補正のテストプログラム
	2013/7/11   Shinji Ushimaru
*/
#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <termios.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
//#include <highgui.h>
//#include "func_extern.h"
#include "controller.h"
#include "mirs.h"
#include "uss.h"
#include "motor.h"
#include "run.h"

static int uss_num=2;
static int dt[4];

extern int theta_data;

int main(){

	int ret;
	int speed;
	int uss1, uss2;
	int count=0;
	int sn =0;

	//初期化
	//ret = initialize();

	//走行距離の指定
	printf("Please input speed :  ");
	ret=scanf("%d",&speed);

	//モータ制御デバイスのオープン
	printf("opening device...\n");
	fd1 = open(MOTOR_L_DEV_FILE, O_RDWR);
	if(fd1 < 0){
		fprintf(stderr, "fd1 open error\n");
		exit(-1);
	}
	fd2 = open(MOTOR_R_DEV_FILE, O_RDWR);
	if(fd2 < 0){
		fprintf(stderr, "fd2 open error\n");
		exit(-1);
	}

        motor_send_start_packet(fd1);
        motor_send_start_packet(fd2);

	//USSスレッドの属性の設定
	pthread_attr_init (&attr_uss);
	sched_param.sched_priority = 20;
	pthread_attr_setschedpolicy(&attr_uss, SCHED_RR);
	pthread_attr_setschedparam (&attr_uss, &sched_param);

	int uss_max=2; //超音波センサの使用数（一台目のセンサからの個数）

	//USSスレッドの生成
	printf("uss thread create..\n");
	//pthread_create(&uss_task, &attr_uss, &uss_read_all, uss_max);
	//pthread_create(&uss_task, &attr_uss, (void *)uss_read_all, (void *)uss_max);

	int par[4];
	par[0]=speed;
	//run_rotate_set(par);
	//set_go_rotate(speed);

	usleep(500*1000); // uss にデータが入るまで少し待つ（必須）

	while(1){
		//go_rotate(); //その場回転
		run_rotate(); //その場回転
/*
		uss1=uss[0];
		uss2=uss[1];
		printf("uss1=%d   uss2=%d   diff_uss12=%d\n",uss1,uss2,uss1-uss2);
*/
		if(count==0){
			sn=uss1-uss2;  //最初のデータを記録する
		}
		// 正面の超音波センサの値の差がなくなるか、符号が変わったところで break する。
		//if(abs(uss1-uss2)<=1 || sn*(uss1-uss2)<0){ //差が１
		//if(abs(uss1-uss2)==0 || sn*(uss1-uss2)<0){ //差がゼロ
		//if(abs(uss1-uss2)<=2 ){ //差が１

		if(abs(uss1-uss2)==0 ){ //差が１
			motor_send_stop_packet(fd1);
			motor_send_stop_packet(fd2);
			break;
		}

		if(count>30) break;
		count++;
		usleep(130*1000);
		//usleep(50*1000);
	}

	motor_send_stop_packet(fd1);
	motor_send_stop_packet(fd2);
	pthread_cancel(uss_task);

	//close(fd0);
	close(fd1);
	close(fd2);
	//close(fd3);
	//close(fd4);
	//close(ctl);

	return 0;
}


