/*
 * test_run_straight.c
 *
 *  Created on: 2013/07/29
 *      Author: d10130
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>
#include <pthread.h>
#include "mirs.h"
#include "motor.h"
#include "run.h"
#include "compass.h"

int main(void){

	// タスクID変数の宣言
	pthread_t compass_task;
	//タスク属性変数の宣言
	pthread_attr_t attr_compass;
	// スケジュールパラメータ
	struct sched_param sched_param;


	//電子コンパススレッド
	pthread_attr_init (&attr_compass);
	sched_param.sched_priority = 20;
	pthread_attr_setschedpolicy(&attr_compass, SCHED_RR);
	pthread_attr_setschedparam(&attr_compass, &sched_param);
	printf("Compass thread create..\n");
	pthread_create(&compass_task, &attr_compass, (void *)compass_thread, NULL);




	Motor* motor_l;
	Motor* motor_r;
	RunStatus* status;
	float speed,x,x_margin;
	double angle_ref;


	// デバイスが開けるか検査
	printf("opening device ...\n");
	if(motor_open(MOTOR_L_DEV_FILE,&motor_l)){
		fprintf(stderr,"[ERROR] cannot open : %s : left motor\n",MOTOR_L_DEV_FILE);
		exit(-1);
	}
	printf("left motor : success\n");
	if(motor_open(MOTOR_R_DEV_FILE,&motor_r)){
		fprintf(stderr,"[ERROR] cannot open : %s : right motor\n",MOTOR_R_DEV_FILE);
		exit(-1);
	}
	printf("right motor : success\n");

	// 走行距離,速度,許容誤差の指定
/*
	printf("\n");
	printf("x[mm] ? ");
	if(scanf("%f",&x) < 1){
		printf("[ERROR] invalid input value\n");
		exit(-1);
	}
	printf("speed[mm/s] ? ");
	if(scanf("%f",&speed) < 1){
		printf("[ERROR] invalid input value\n");
		exit(-1);
	}
	printf("margin[mm] ? ");
	if(scanf("%f",&x_margin) < 1){
		printf("[ERROR] invalid input value\n");
		exit(-1);
	}
*/
	x=-1000;	
	speed=15;
	x_margin=20;



	while(getchar()!='\n');
	printf("motor start");
	while(angle==0.0){
		sleep(3);	
	}


	// 目標距離との誤差が x_margin[mm] 以下になるまで直進走行
	while(1){
		float x_l,x_r;
		float v_l,v_r;
		
		// 初期設定
		printf("\n");
		printf("starting ...\n");

		printf("angle = %6.2f[deg]\n\n",angle);
		printf("angle_ref[deg] ? \n");
		if(scanf("%lf",&angle_ref) < 1){
			printf("[ERROR] invalid input value\n");
			exit(-1);
		}
		status = run_straight_init(motor_l,motor_r);

		while( fabs(x_margin) < fabs(x - run_straight_to(x,speed,angle_ref,status)) ){
			x_l = motor_get_count(motor_l) * MIRS_DISTANCE_TO_PULSE_RATIO;
			x_r = motor_get_count(motor_r) * MIRS_DISTANCE_TO_PULSE_RATIO;
			v_l = motor_get_speed(motor_l) * MIRS_DISTANCE_TO_PULSE_RATIO;
			v_r = motor_get_speed(motor_r) * MIRS_DISTANCE_TO_PULSE_RATIO;
			#ifdef __debug_run__
			printf("v_l = %4.2f[mm/s]  v_r = %4.2f[mm/s]\n",v_l,v_r);
			printf("  x_l = %7.2f[mm]  x_r = %7.2f[mm]\n",x_l,x_r);
			printf("angle = %6.2f[deg]\n\n",angle);
			#endif
		}
		
		// 停止処理
		run_straight_finish(status);
		motor_set_count(motor_l,motor_get_count(motor_l));
		motor_set_count(motor_r,motor_get_count(motor_r));
		
		printf("end");
		//break;
	}

	// モータとの通信を終了
	printf("\n");
	printf("closing device ...\n");
	motor_close(motor_l);
	motor_close(motor_r);
	pthread_join(compass_task,NULL);

	return 0;
}
