/*
	uss_read:
		Read distance data mesuared by USS.
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <termios.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include "mirs.h"
#include "uss.h"

void uss_read(int uss_no){
	int data;
	
	while(1){
		pthread_testcancel();
		data = uss_get(uss_no);
		usleep(500*1000);
		if(data == -1){
			printf("uss_read: uss_no error\n");
			pthread_exit((void*)-1);
		}
		uss[uss_no - 1] = data;
		printf("uss[%d] = %d\n", uss_no, uss[uss_no - 1]);
	}
	
	pthread_exit(0);
	return;
}

void uss_read_all(int max_num){
	int data;
	int i;

	printf("max_num=%d\n",max_num);
	
	//while(1){
		printf("uss data in thread \n");
		for(i=0;i<max_num;i++){
			pthread_testcancel();
			data = uss_get(i+1);
			if(data == -1){
				printf("uss_read: uss_no error\n");
				pthread_exit((void*)-1);
			}
			usleep(30*1000); //30msec以上の wait を入れないと、隣り合うUSSが干渉する。
			uss[i] = data;
			printf("uss[%d] = %d\n", i+1, uss[i]);
		}
		printf("uss12_diff = %d\n", uss[0]-uss[1]);
	//}
	
	pthread_exit(0);
	return;
}


int uss_get(int uss_num){
	unsigned char rs_rbuffer[2];
	unsigned char rs_sbuffer[1];
	int c=0,x;
	int data = 99999;
	int i=0;
	//int rval;
	struct termios oldtio;

	/*
	if(uss_num < 0 || uss_num > 4) return(-1);
	sprintf((char*)rs_sbuffer,"%c",(char)uss_num);

	fd0=open(S_PORT,O_RDWR | O_NOCTTY | O_NONBLOCK);

	set_serial_port(fd0,&oldtio);
	put_serial_string(fd0,(char*)rs_sbuffer);
	*/

	// 2バイトのデータ受けとるまで無限ループする。
	while(1){
		c=get_serial_char(fd0);
		rs_rbuffer[i] = c;
		i++;
		if(i==2){
			//2バイト目のデータが 0xff であったら応答なしとして、dataに99999を入れる
			if(rs_rbuffer[1]==0xff){
				//printf("\"%s\" receive no response\n",S_PORT);
				data = 99999;
				break;
			}
			c=rs_rbuffer[1];
			x=c<<8;
			c=rs_rbuffer[0];
			data=x+c+20;
			break;
		}
	}

	//close_serial_port(fd0,&oldtio);

	return (data);
}
