#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <termios.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include <termios.h>
#include <stdint.h>

// DEBUG モード使用するときに define する。使用しない場合はコメントアウトする。
//#define __DEBUG_USS__

//uss_func define
#define _POSIX_SOURCE 1 /* POSIX comliant source (POSIX準拠のソース)*/

//#define BAUDRATE B9600

//uss_get define
/*
#define STX 0x02
#define ETX 0x03
#define ENQ 0x05
#define ACK 0x06
#define LF 0x0a
#define CR 0x0d
#define NAK 0x15
*/
#define S_PORT "/dev/ttyS0"

#define circle_radious 360      /* circle diameter of going arround a post */
/* USS measurment parmeter */
#define USS_MAX 150             /* POST distace maxmimum [cm]*/
#define USS_MIN 20              /* POST distace minimum [cm]*/
#define MCENTER_USS3_DIS 138            /* Distance between MIRS center and USS3 */
#define MCENTER_USS12_DIS 120           /* Distance between MIRS center and USS1,2 */
#define USS12_DIFF  0           /* USS Diffrence = USS1 - USS2  */
#define USS_CORRECT -30 /* Difference of USS data from correct distance */

// extern宣言

//引数で指定したUSS番号の値を読み込み。戻り値：読み取り値(cm) 
extern int uss_read(int);
//引数で指定した数のUSSの値を取得する。 計測値は共有変数の int uss[4] に入る。
extern void uss_read_all(int);
//別スレッドで引数で指定した数のUSSの値を取得する。 計測値は共有変数の int uss[4] に入る。
extern void uss_read_thread(int);

//USSシリアル通信奸計の関数
extern int set_serial_port(int, struct termios*);
extern void close_serial_port(int, struct termios*);
extern int put_serial_char(int, char);
extern int put_serial_string(int, char*);
extern int get_serial_char(int);

//extern volatile int uss12;
//extern volatile int uss_data;
extern volatile int uss[4];

//デバイスファイル
extern int fd0;
#include <pthread.h>
#include <stdint.h>


// タスクID変数の宣言
extern pthread_t uss_task;
//タスク属性変数の宣言
extern pthread_attr_t attr_uss;
extern void uss_read_thread(int);

